models.py
from app import db
from flask_login import UserMixin
from flask_wtf import FlaskForm
from wtforms import StringField, PasswordField, SubmitField
from wtforms.validators import InputRequired, Length, ValidationError, EqualTo


class Users(db.Model, UserMixin):
    id = db.Column(db.Integer, primary_key=True)
    username = db.Column(db.String(100), unique=True, nullable=False)
    email = db.Column(db.String(100), unique=True, nullable=False)
    password = db.Column(db.String(100), nullable=False)

    def __init__(self, username, email, password):
        self.username = username
        self.email = email
        self.password = password

class SignupForm(FlaskForm):
    username = StringField(validators=[
        InputRequired(),
        Length(min=3, max=100)
    ],
        render_kw={"placeholder": "Username", "class": "input is-large"})

    email = StringField(validators=[
        InputRequired(),
        Length(min=6, max=100)
    ],
        render_kw={"placeholder": "Email", "class": "input is-large"})

    password = PasswordField(validators=[
        InputRequired(),
        Length(min=8, max=100)
    ],
        render_kw={"placeholder": "Password", "class": "input is-large"})

    repeat_password = PasswordField(validators=[
        InputRequired(),
        Length(min=8, max=100),
        EqualTo('password', message='Both password fields must be equal!')
    ],
        render_kw={"placeholder": "Repeat Password", "class": "input is-large"})

    submit = SubmitField("Register", render_kw={"class": "button is-block is-info is-large is-fullwidth"})

    def validate_username(self, username):
        alphabet = 'abcdefghijklmnopqrstuvwxyz'
        digits = '1234567890'
        existing_username = Users.query.filter_by(username=username.data).first()
        beginning_letter = username.data[0].lower() in alphabet
        matching_letters = True
        for symb in username.data:
            if not (symb in alphabet or symb == '_' or symb in digits or symb in alphabet.upper()):
                matching_letters = False
                break
        print(f'DEBUG | existing_username = {existing_username}, beginning_letter = {beginning_letter}')
        print(f'DEBUG | matching_letters = {matching_letters}')
        if existing_username is not None:
            print(f'DEBUG | User exists')
            raise ValidationError('That user already exists.')
        if not (beginning_letter or matching_letters):
            print(f'DEBUG | Invalid username')
            raise ValidationError('Invalid username.')

    def validate_email(self, email):
        existing_email = Users.query.filter_by(email=email.data).first()
        email_matches = '@' in email.data
        print(f'DEBUG | existing_email = {existing_email}, email_matches = {email_matches}')
        if existing_email is not None:
            print(f'DEBUG | Email exists.')
            raise ValidationError('Email already registered.')
        if not email_matches:
            print(f'DEBUG | Invalid email')
            raise ValidationError('Invalid email.')

    def validate_password(self, password):
        password_string = password.data
        symbols = '%$#@&*^|\/~[]{}(),._-'
        alphabet = 'abcdefghijklmnopqrstuvwxyz'
        digits = '1234567890'
        contains_symbol = False
        contains_uppercase = False
        contains_lowercase = False
        contains_number = False
        contains_invalid_symbols = True
        for symb in password_string:
            if symb in symbols:
                contains_symbol = True
            elif symb in digits:
                contains_number = True
            elif symb in alphabet:
                contains_lowercase = True
            elif symb in alphabet.upper():
                contains_uppercase = True
            else:
                contains_invalid_symbols = False
        print(f'DEBUG | contains_symbol = {contains_symbol}, contains_uppercase = {contains_uppercase}')
        print(f'DEBUG | contains_lowercase = {contains_lowercase}, contains_number = {contains_number}')
        print(f'DEBUG | contains_invalid_symbols = {contains_invalid_symbols}')
        if contains_symbol and contains_uppercase and contains_lowercase\
                and contains_number and not contains_invalid_symbols:
            print(f'DEBUG | Invalid password')
            raise ValidationError("Invalid password.")


class LoginForm(FlaskForm):
    username = StringField(validators=[
        InputRequired(),
        Length(min=6, max=100)
    ],
        render_kw={"placeholder": "Username", "class": "input is-large"})

    password = PasswordField(validators=[
        InputRequired(),
        Length(min=8, max=100)
    ],
        render_kw={"placeholder": "Password", "class": "input is-large"})
    submit = SubmitField('Login', render_kw={"class": "button is-block is-info is-large is-fullwidth"})

app.py
from os import path
from flask import Flask
from flask_sqlalchemy import SQLAlchemy
from flask_bcrypt import Bcrypt
from flask_login import LoginManager

DB_NAME = 'users_database.db'
db = SQLAlchemy()
bcrypt = Bcrypt()
basedir = path.dirname(path.abspath(__file__))


def create_app():  # init script
    app = Flask(__name__)

    # Configs for app
    app.config['SECRET_KEY'] = '76XXq4DegnHFzvr7R6vH6qU54'
    app.config['SQLALCHEMY_DATABASE_URI'] = 'sqlite:///' + path.join(basedir, DB_NAME)
    app.config['SQLALCHEMY_TRACK_MODIFICATIONS'] = False

    db.init_app(app)
    bcrypt.init_app(app)

    from views import views
    from auth import auth
    app.register_blueprint(views, url_prefix='/')
    app.register_blueprint(auth, url_prefix='/')

    from models import Users
    create_database(app)

    login_manager = LoginManager()
    login_manager.init_app(app)
    login_manager.login_view = 'auth.login'

    @login_manager.user_loader
    def load_user(user_id):
        return Users.query.get(int(user_id))

    return app


def create_database(app):
    if not path.exists(DB_NAME):
        with app.app_context():
            db.create_all()
        print('DEBUG | Created database')


app = create_app()

if __name__ == '__main__':
    app.run(debug=True)

auth.py
from flask import Blueprint, redirect, url_for, render_template, flash, request
from flask_login import login_user, login_required, logout_user
from models import Users, LoginForm, SignupForm
from app import db, bcrypt

auth = Blueprint('auth', __name__)


@auth.route('/login', methods=['GET', 'POST'])
def login():
    form = LoginForm()

    if request.method == "POST":
        if form.validate_on_submit():
            user = Users.query.filter_by(username=form.username.data).first()
            if user:
                if bcrypt.check_password_hash(user.password, form.password.data):
                    login_user(user)
                    return redirect(url_for('views.welcome'))
                else:
                    flash("Wrong password.")
            else:
                flash("User doesn't exist.")
        else:
            flash('Invalid username or password.')

    return render_template('login.html', form=form)


@auth.route('/signup', methods=['GET', 'POST'])
def signup():
    form = SignupForm()

    if request.method == "POST":
        if form.validate_on_submit():
            hashed_password = bcrypt.generate_password_hash(form.password.data)
            new_user = Users(username=form.username.data, email=form.email.data, password=hashed_password)
            db.session.add(new_user)
            db.session.commit()
            print('DEBUG | Created new user')
            return redirect(url_for('auth.login'))
        else:
            flash('Invalid username or password.')

    return render_template('signup.html', form=form)


@auth.route('/logout', methods=['GET', 'POST'])
@login_required
def logout():
    logout_user()
    return redirect(url_for('auth.login'))

views.py
from flask import Blueprint, render_template
from flask_login import login_required, current_user

views = Blueprint('views', __name__)


@views.route('/')
def index():
    return render_template('index.html')


@views.route('/welcome')
@login_required
def welcome():
    return render_template("welcome.html", user=current_user.username)

templates/base.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Flask Dev Test</title>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bulma@0.9.4/css/bulma.min.css">
</head>
<body>
    <section class="hero is-primary is-fullheight">
        <div class="hero is-primary">
            <div class="hero-head">
                <nav class="navbar">
                    <div class="container">
                        <div id="navbarMenuHeroA" class="navbar-menu">
                            <div class="navbar-start">
                                <p class="navbar-item">Flask Login</p>
                            </div>
                            <div class="navbar-end">
                                <a href="{{ url_for('views.index') }}" class="navbar-item">Home</a>
                                <a href="{{ url_for('auth.login') }}" class="navbar-item">Login</a>
                                <a href="{{ url_for('auth.signup') }}" class="navbar-item">Sign Up</a>
                                <a href="{{ url_for('auth.logout') }}" class="navbar-item">Logout</a>
                            </div>
                        </div>
                    </div>
                </nav>
            </div>
        </div>
        <div class="hero-body">
            <div class="container has-text-centered">
                {% block content %}
                {% endblock %}
            </div>
        </div>
    </section>
</body>
</html>

templates/index.html
{% extends "base.html" %}

{% block content %}
<h1 class="title">
    Flask Login Example Page
</h1>
<h2 class="subtitle">
    Using SQLite 3
</h2>
{% endblock %}

templates/login.html
{% extends "base.html" %}

{% block content %}
<div class="column is-4 is-offset-4">
    <h3 class="title">Login</h3>
    <div class="box">
        {% with messages = get_flashed_messages() %}
            {% if messages %}
                <div class="is-large notification is-danger">
                    {% for message in messages %}
                        {{ message }}
                    {% endfor %}
                </div>
            {% endif %}
        {% endwith %}
        <form method="POST" action="/login">
            {{ form.hidden_tag() }}
            <div class="field">
                <div class="control">
                    {{ form.username }}
                </div>
            </div>
            <div class="field">
                <div class="control">
                    {{ form.password }}
                </div>
            </div>
            {{ form.submit }}
        </form>
    </div>
</div>
{% endblock %}

templates/signup.html
{% extends "base.html" %}

{% block content %}
<div class="column is-4 is-offset-4">
    <h3 class="title">Sign Up</h3>
    <div class="box">
        {% with messages = get_flashed_messages() %}
            {% if messages %}
                <div class="is-large notification is-danger">
                    {% for message in messages %}
                        {{ message }}
                    {% endfor %}
                </div>
            {% endif %}
        {% endwith %}
        <form method="POST" action="/signup">
            {{ form.hidden_tag() }}
            <div class="field">
                <div class="control">
                    {{ form.username }}
                </div>
            </div>
            <div class="field">
                <div class="control">
                    {{ form.email }}
                </div>
            </div>
            <div class="field">
                <div class="control">
                    {{ form.password }}
                </div>
            </div>
            <div class="field">
                <div class="control">
                    {{ form.repeat_password }}
                </div>
            </div>
            {{ form.submit }}
        </form>
    </div>
</div>
{% endblock %}

templates/welcome.html
{% extends "base.html" %}

{% block content %}
<h1 class="title">
    Welcome, {{ user }}!
</h1>
<h2 class="subtitle">
    Now it finally works!
</h2>
{% endblock %}